"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ERC7529Contract = void 0;
const neverthrow_1 = require("neverthrow");
const BaseContract_js_1 = require("../implementations/BaseContract.js");
const index_js_1 = require("../interfaces/objects/index.js");
class ERC7529Contract extends BaseContract_js_1.BaseContract {
    constructor(providerOrSigner, contractAddress, abi) {
        // If you provide your own ABI, we'll use that, but we have a built-in default ERC7529 ABI
        if (abi == undefined) {
            abi = index_js_1.ContractsAbis.ERC7529Abi.abi;
        }
        super(providerOrSigner, contractAddress, abi);
        this.providerOrSigner = providerOrSigner;
        this.contractAddress = contractAddress;
    }
    addDomain(domain, overrides) {
        return this.writeToContract("addDomain", [domain], overrides);
    }
    removeDomain(domain, overrides) {
        return this.writeToContract("removeDomain", [domain], overrides);
    }
    getDomains() {
        return neverthrow_1.ResultAsync.fromPromise(
        // returns array of domains
        this.contract.getDomains(), (e) => {
            return this.generateError(e, "Unable to call getDomains()");
        });
    }
}
exports.ERC7529Contract = ERC7529Contract;
//# sourceMappingURL=ERC7529Contract.js.map